#include<iostream>
#include <algorithm>
#include<cmath>
using namespace std;
int main ()
{
    int n,m,k1,x,b1=0,t;
    cin>>t;
    int T[t];
    for(int i=0;i<t;i++)
    {
        b1=0;
        k1=0;
        x=0;
    cin>>n>>m;
    int a[n],b[n];
    for(int i=0; i<n; i++)
        cin>>a[i];
    for(int j=0; j<m; j++)
        cin>>b[j];
    x=abs(a[0]-a[1]);
    for(int i=1; i<n-1; i++)
    {
        k1=abs(a[i]-a[i+1]);
        if(k1<=x)
            x=k1;
    }
    for(int i=0; i<m; i++)
    {
        if(abs(a[0]-b[i])%x==0)
            b1--;
    }
    if(b1<0)
        T[i]=0;
    else
        T[i]=1;
    }
    for(int i=0;i<t;i++)
        cout<<T[i]<<endl;
    return 0;
}